<?php

require_once dirname(dirname(__FILE__)) . '/model/filelinkmgr/filelinkmgr.class.php';

/**
* Class for backend table
*/
class FileLinkMgrIndexManagerController extends modExtraManagerController {
    /** @var FileLinkMgr $filelinkmgr */
    public $filelinkmgr;
    public function initialize() {
        $this->filelinkmgr = new FileLinkMgr($this->modx);
        $this->addCss($this->filelinkmgr->options['cssUrl'].'mgr.css');
            $this->addJavascript($this->filelinkmgr->options['jsUrl'].'mgr/filelinkmgr.js');
            $this->addHtml('<script type="text/javascript">
            Ext.onReady(function() {
                FileLinkMgr.options = '.$this->modx->toJSON($this->filelinkmgr->options).';
            });
            </script>');
            return parent::initialize();
    }
    public function getLanguageTopics() {
            return array('filelinkmgr:default');
    }
    public function checkPermissions() { return true;}
    public function process(array $scriptProperties = array()) {}
    public function getPageTitle() { return $this->modx->lexicon('filelinkmgr'); }
    public function loadCustomCssJs() {
        $this->addJavascript($this->filelinkmgr->options['jsUrl'].'mgr/widgets/home.panel.js');
        $this->addLastJavascript($this->filelinkmgr->options['jsUrl'].'mgr/sections/index.js');
    }
    public function getTemplateFile() {
        return $this->filelinkmgr->options['templatesPath'].'home.tpl';
    }
}
