<?php
/**
* This processor exports a config and makes it downloadable to the user
*
* @var FileLinkMgr $filelinkmgr --> instance of FileLinkMgr class
* @var Array $requiredFields --> Required fields to check
*/
class FileLinkMgrLinkGenerateProcessor extends modProcessor {
    private $filelinkmgr;
    private $requiredFields = array(
      'file'
    );

    public function initialize(){
      $this->filelinkmgr = $this->modx->getService('filelinkmgr', 'FileLinkMgr', $this->modx->getOption('filelinkmgr.core_path', null, $this->modx->getOption('core_path').'components/filelinkmgr/').'model/filelinkmgr/', array());
      if(!$this->filelinkmgr instanceof FileLinkMgr){
        return false;
      }

      foreach($this->requiredFields as $requiredField){
        if(empty($this->getProperty($requiredField))){
          $this->addFieldError($requiredField, $this->modx->lexicon('field_required'));
        }
      }

      return true;
    }

    public function process(){
      $mediasource = (!empty($this->filelinkmgr->getOption('mediaSource'))) ? $this->filelinkmgr->getOption('mediaSource') : $this->modx->getOption('default_media_source');
      $mediasource = $this->modx->getObject('sources.modMediaSource', $mediasource);

      $fileUrl = $mediasource->prepareOutputUrl($this->getProperty('file'));
      $hostUrl = (!empty($this->filelinkmgr->getOption('site_url'))) ? $this->filelinkmgr->getOption('site_url') : $this->modx->getOption('site_url');

      $properties['fileLink'] = $hostUrl.$fileUrl;

      return $this->success('success', $properties);
    }
}
return 'FileLinkMgrLinkGenerateProcessor';
