FileLinkMgr.panel.Home = function(options) {
  options = options || {};
  Ext.apply(options, {
    border: false,
    baseCls: 'modx-formpanel',
    cls: 'container',
    items: [{
      html: '<h2>' + _('filelinkmgr') + '</h2>',
      border: false,
      cls: 'modx-page-header'
    }, {
      xtype: 'modx-tabs',
      defaults: {
        border: false,
        autoHeight: true
      },
      border: true,
      items: [{
          title: _('filelinkmgr.link_manager'),
          defaults: {
            autoHeight: true
          },
          items: [{
            html: '<p>' + _('filelinkmgr.management_desc') + '</p>',
            border: false,
            bodyCssClass: 'panel-desc'
          }, {
            xtype: 'panel',
            cls: 'main-wrapper',
            layout: 'form',
            labelAlign: 'left',
            labelWidth: 125,
            width: 475,
            items: [{
              fieldLabel: _('filelinkmgr.choose_file'),
              xtype: 'modx-combo-browser',
              hideFiles: true,
              source: MODx.config['filelinkmgr.mediaSource'] != null ? MODx.config['filelinkmgr.mediaSource'] : MODx.config.default_media_source,
              hideSourceCombo: true,
              name: 'file',
              id: 'file',
              anchor: '100%',
            }, {
              fieldLabel: _('filelinkmgr.link'),
              xtype: 'textfield',
              name: 'fileLink',
              id: 'fileLink',
              selectOnFocus: true,
              anchor: '100%',
              hidden: true,
            }, {
              xtype: 'panel',
              cls: 'button-holder',
              anchor: '100%',
              items: [{
                xtype: 'button',
                cls: 'primary-button',
                text: _('filelinkmgr.generate_link'),
                handler: function(btn, e) {
                  e.preventDefault();

                  Ext.Ajax.request({
                    url: FileLinkMgr.options.connectorUrl,
                    method: 'GET',
                    params: {
                      action: 'mgr/filelinkmgr/generateUrl',
                      file: Ext.getCmp('file').getValue(),
                      HTTP_MODAUTH: MODx.siteId
                    },
                    success: function(response){
                      console.log(response);
                      var processorData = JSON.parse(response.responseText);
                      if(processorData.success){
                        if(processorData.data.length > 0){
                          // Show errors if 'data' is set in response
                          var fieldErrors = processorData.data;
                          for(var i = 0; i < processorData.data.length; i++){
                            Ext.MessageBox.alert(_('error'),_('filelinkmgr.' + processorData.data[i].id + '_field_required'));
                          }
                        } else {
                          var fileLink = processorData.object.fileLink;
                          Ext.getCmp('fileLink').setValue(fileLink);
                          Ext.getCmp('fileLink').show();
                          Ext.getCmp('fileLink').focus(function(){ $(this).select(); });
                        }
                      }
                    },
                    failure: function(response){
                      console.log("ERROR "+response.status+" "+response.statusText+" whilst getting link for file.");
                    }
                  });

                },
              }]
            }]
          }]
        }]
        // only to redo the grid layout after the content is rendered
        // to fix overflow components' panels, especially when scroll bar is shown up
        ,
      listeners: {
        'afterrender': function(tabPanel) {
          tabPanel.doLayout();
        }
      }
    }]
  });
  FileLinkMgr.panel.Home.superclass.constructor.call(this, options);
};
Ext.extend(FileLinkMgr.panel.Home, MODx.Panel);
Ext.reg('filelinkmgr-panel-home', FileLinkMgr.panel.Home);
